<div class="row">

	<div class="col-md-10 col-md-offset-1">
	
		<!-- ignore empty links with + -->
		{{ $headers := findRE "<h[2-6].*?>(.|\n])+?</h[2-6]>" .Content }}
		<!-- at least one header to link to -->
		{{ $has_headers := ge (len $headers) 1 }}
		<!-- a post can explicitly disable Table of Contents with toc: false -->
		{{ $show_toc := (eq $.Params.toc true) }}
		{{ if and $has_headers $show_toc }}

		<div class="table-of-contents toc">
		    <!-- TOC header -->
		    <h4>What’s on this page</h4>
		    	<ul class="toc-level0">
		        {{ range $i, $header := $headers }}
					{{ $headerLevel := index (findRE "[2-6]" . 1) 0 }}
					{{ $headerLevel := len (seq $headerLevel) }}

					{{ $anchorID := ($header | plainify | htmlUnescape | urlize) }}

					{{ if ne $i 0 }}
					{{ $prevHeaderLevel := index (findRE "[2-6]" (index $headers (sub $i 1)) 1) 0 }}
					{{ $prevHeaderLevel := len (seq $prevHeaderLevel) }}

					  {{ if gt $headerLevel $prevHeaderLevel }}
					    {{ range seq (sub $headerLevel $prevHeaderLevel) }}
					      <ul class="toc-level{{ . }}">
					    {{end}}
					  {{end}}

					  {{ if lt $headerLevel $prevHeaderLevel }}
					    {{ range seq (sub $prevHeaderLevel $headerLevel) }}
					      </li></ul></li>
					    {{end}}
					  {{end}}

					  {{ if eq $headerLevel $prevHeaderLevel }}
					    </li>
					  {{end}}

					  <li>
					    <a href="#{{ $anchorID }}">{{ $header | plainify | htmlUnescape }}</a>

					  {{ if eq $i (sub (len $headers) 1) }}
					    {{ range seq (sub $prevHeaderLevel $headerLevel) }}
					      </li></ul></li>
					    {{end}}
					  {{end}}
					{{else}}
					<li>
					<a href="#{{ $anchorID }}">{{ $header | plainify | htmlUnescape }}</a>
					{{end}}
					{{end}}

					{{ $firstHeaderLevel := len (seq (index (findRE "[2-6]" (index $headers 0) 1) 0)) }}
					{{ $lastHeaderLevel := len (seq (index (findRE "[2-6]" (index $headers (sub (len $headers) 1)) 1) 0)) }}
					{{ range seq (sub $lastHeaderLevel $firstHeaderLevel) }}
					</li></ul></li>
					{{end}}
				</ul>
		</div>
		{{ end }}
		
	</div>
	
</div>